/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
/* Gateway db utility test
 * Europagate, 1995
 *
 * $Log: gwdbtest.c,v $
 * Revision 1.3  1995/12/20 16:28:08  adam
 * Extra parameter block to gw_db_open. If block is 0 gw_db_open
 * returns NULL if lock couldn't be satisfied.
 * Minor changes in iso2709.c.
 *
 * Revision 1.2  1995/05/16  09:40:53  adam
 * LICENSE.
 *
 * Revision 1.1  1995/03/27  08:25:02  adam
 * New module gip: Gateway IPc module.
 * New module gw-db: Gateway hash-db module (user information table).
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include <gw-db.h>

int main (int argc, char **argv)
{
    char word[1024];
    GW_DB gwdb;
    int no;
    void *buf;
    size_t count;
    int r;
    int no_insert = 0;

    gwdb = gw_db_open ("db.test", 1, 1);
    for (no = 0; scanf ("%s", word) == 1; no++)
    {
        r = gw_db_lookup (gwdb, word, strlen(word), & buf, &count);
        if (r== 0)
	{
	    char info[25];
	    sprintf (info, "%d", no);
	    if (gw_db_insert (gwdb, word, strlen(word), info, strlen (info)))
	    {
	        printf ("gw_db_insert of %s failed\n", word);
		exit (1);
            }
	    no_insert++;
	}
	else if (r == 1)
	{
	    free (buf);
	}
	else
	{
	    printf ("gw_db_lookup of %s failed\n", word);
	    exit (1);
	}
    }
    gw_db_close (gwdb);
    printf ("Lookup: %d. Insert: %d\n", no, no_insert);
    exit (0);
}
