/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * $Log: wtest.c,v $
 * Revision 1.3  1996/02/12 10:10:33  adam
 * Resource/config system used by the gateway.
 *
 * Revision 1.2  1996/01/09  10:46:51  adam
 * New defines: LOGDIR/EGWDIR/CGIDIR set in Makefile.
 *
 * Revision 1.1  1995/10/20  11:49:28  adam
 * First version of www gateway.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "wproto.h"

static WCLIENT wcl;
static char *mod = "wtest";

int main()
{
    int timeout = 60;
    int counter = 0;
    int i;

    gw_log_init ("egw");
    gw_log_level (GW_LOG_ALL);
    gw_log_file (GW_LOG_ALL, "wtest_log");
    gw_log (GW_LOG_STAT, mod, "Europagate www test");

    if (!(wcl = wproto_init ("/tmp/egw")))
    {
        gw_log (GW_LOG_FATAL, mod, "init");
        exit (1);
    }
    while (wproto_process(wcl, timeout) > 0)
    {
        gw_log (GW_LOG_DEBUG, mod, "Process input");
    	wo_clear (wcl, "text/html");
    	wo_printf (wcl, "<HTML><TITLE>Test page</TITLE>\n");
    	wo_printf (wcl, "Hello from the test program.<BR>\n");
    	wo_printf (wcl, "This is #%d time that you call me!!<BR>\n", ++counter);
    	wo_printf (wcl, "My parameters are '%s'<BR>\n", wcl->wf_parms);
    	wo_printf (wcl, "My server FIFO is '%s'<BR>\n", wcl->wf_serverp);
    	for (i = 0; *wcl->wf_data[i].name; i++)
    	{
	    wo_printf (wcl, "%s = %s<BR>\n", wcl->wf_data[i].name, 
                                             wcl->wf_data[i].value);
	}
    	wo_printf (wcl, "Here is a button which references ");
    	wo_printf (wcl, "<A HREF=\"http://localhost/cgi-bin/egwcgi/%d/%d\">me</A> "
		  "again.\n", getpid(), counter);
        wo_printf (wcl, "</HTML>\n");
        wo_finish (wcl);
        gw_log (GW_LOG_DEBUG, mod, "Process end");
    }
    wproto_terminate (wcl);
    return 0;
}
